Main Page Class Hierarchy Alphabetical List Compound List File List Compound Members File Members Related Pages

# ACE_Double_Linked_List_Iterator Class Template Reference

Implements an iterator for a double linked list ADT. More...

`#include <Containers_T.h>`

Inheritance diagram for ACE_Double_Linked_List_Iterator:

[legend]
Collaboration diagram for ACE_Double_Linked_List_Iterator:

[legend]
List of all members.

## Public Methods
| ACE_Double_Linked_List_Iterator (const ACE_Double_Linked_List< T > &)
void | reset (ACE_Double_Linked_List< T > &)
| Retasks the iterator to iterate over a new Double_Linked_List. More...
int | first (void)
| Move to the first element in the list. Returns 0 if the list is empty, else 1. More...
int | advance (void)
| Move forward by one element in the list. Returns 0 when all the items in the list have been seen, else 1. More...
T * | advance_and_remove (int dont_remove)
| Advance the iterator while removing the original item from the list. More...
ACE_Double_Linked_List_Iterator< T > & | operator++ (void)
| Prefix advance. More...
ACE_Double_Linked_List_Iterator< T > | operator++ (int)
| Postfix advance. More...
ACE_Double_Linked_List_Iterator< T > & | operator-- (void)
| Prefix reverse. More...
ACE_Double_Linked_List_Iterator< T > | operator-- (int)
| Postfix reverse. More...
void | dump (void) const
| Dump the state of an object. More...
## Public Attributes
| ACE_ALLOC_HOOK_DECLARE
| Declare the dynamic allocation hooks. More...

## Detailed Description

### template<class T>
class ACE_Double_Linked_List_Iterator< T >

Implements an iterator for a double linked list ADT.

Iterate thru the double-linked list. This class provides an interface that let users access the internal element addresses directly. Notice <class T> must declare ACE_Double_Linked_List<T>, ACE_Double_Linked_List_Iterator_Base <T> and ACE_Double_Linked_List_Iterator as friend classes and class T should also have data members T* next_ and T* prev_.

## Constructor & Destructor Documentation

template<class T>
ACE_Double_Linked_List_Iterator< T >::ACE_Double_Linked_List_Iterator | ( | const ACE_Double_Linked_List< T > & | dll | ) |

## Member Function Documentation

template<class T>
int ACE_Double_Linked_List_Iterator< T >::advance | ( | void |  | ) |

| Move forward by one element in the list. Returns 0 when all the items in the list have been seen, else 1. Reimplemented in ACE_DLList_Iterator.

template<class T>
T * ACE_Double_Linked_List_Iterator< T >::advance_and_remove | ( | int | dont_remove | ) |

| Advance the iterator while removing the original item from the list. Return a pointer points to the original (removed) item. If <dont_remove> equals 0, this function behaves like <advance> but return 0 (NULL) instead.

template<class T>
void ACE_Double_Linked_List_Iterator< T >::dump | ( | void |  | ) | const

| Dump the state of an object. Reimplemented in ACE_DLList_Iterator.

template<class T>
int ACE_Double_Linked_List_Iterator< T >::first | ( | void |  | ) |

| Move to the first element in the list. Returns 0 if the list is empty, else 1.

template<class T>
ACE_Double_Linked_List_Iterator< T > ACE_Double_Linked_List_Iterator< T >::operator++ | ( | int |  | ) |

| Postfix advance.

template<class T>
ACE_Double_Linked_List_Iterator< T > & ACE_Double_Linked_List_Iterator< T >::operator++ | ( | void |  | ) |

| Prefix advance.

template<class T>
ACE_Double_Linked_List_Iterator< T > ACE_Double_Linked_List_Iterator< T >::operator-- | ( | int |  | ) |

| Postfix reverse.

template<class T>
ACE_Double_Linked_List_Iterator< T > & ACE_Double_Linked_List_Iterator< T >::operator-- | ( | void |  | ) |

| Prefix reverse.

template<class T>
void ACE_Double_Linked_List_Iterator< T >::reset | ( | ACE_Double_Linked_List< T > & | dll | ) |

| Retasks the iterator to iterate over a new Double_Linked_List. This allows clients to reuse an iterator without incurring the constructor overhead. If you do use this, be aware that if there are more than one reference to this iterator, the other "clients" may be very bothered when their iterator changes. @ Here be dragons. Comments? Reimplemented from ACE_Double_Linked_List_Iterator_Base.

## Member Data Documentation

template<class T>
ACE_Double_Linked_List_Iterator::ACE_ALLOC_HOOK_DECLARE

| Declare the dynamic allocation hooks. Reimplemented from ACE_Double_Linked_List_Iterator_Base.

The documentation for this class was generated from the following files:

- Containers_T.h
- Containers_T.cpp